﻿using Syncfusion.WinForms.DataGrid;
using Syncfusion.WinForms.DataGrid.Enums;
using Syncfusion.WinForms.DataGrid.Events;
using Syncfusion.WinForms.DataGrid.Helpers;
using Syncfusion.WinForms.DataGrid.Renderers;
using Syncfusion.WinForms.DataGrid.Styles;
using Syncfusion.WinForms.GridCommon.ScrollAxis;
using System;
using System.Collections.ObjectModel;
using System.Drawing;
using System.Linq;
using System.Windows.Forms;

namespace DataGrid_GettingStartedDemo
{
    public partial class Form1 : Form
    {
        OrderInfoCollection orderInfoCollection = new OrderInfoCollection();
        public Form1()
        {
            InitializeComponent();

            this.sfDataGrid1.UnboundRowCellRenderers.Remove("UnboundRowCell");
            this.sfDataGrid1.UnboundRowCellRenderers.Add("UnboundRowCell", new UnboundCellRenderer());
            sfDataGrid1.DataSource = orderInfoCollection.Orders;
            CreateUnboundRow();
        }

        private void CreateUnboundRow()
        {            
            this.sfDataGrid1.UnboundRows.Add(new GridUnboundRow() { Position = VerticalPosition.Bottom, ShowBelowSummary = false });
        }

        private void RemoveBtn_Click(object sender, System.EventArgs e)
        {
            orderInfoCollection.RemoveItem();
        }

        private void AddBtn_Click(object sender, System.EventArgs e)
        {
            orderInfoCollection.AddItem();
        }
    }

    public class UnboundCellRenderer : GridUnboundCellRenderer
    {
         
        protected override void OnRender(
           Graphics paint,
           Rectangle cellRect,
           string cellValue,
           CellStyleInfo style,
           DataColumnBase column, RowColumnIndex rowColumnIndex)
        {
            if (column.GridColumn.MappingName == "Price")
            {
                ObservableCollection<OrderInfo> dataGridOrders = (column.UnboundRowInfo.OriginalSender as SfDataGrid).DataSource as ObservableCollection<OrderInfo>;
                cellValue = dataGridOrders.Sum(items => items.Price).ToString("0.00");
            }
            base.OnRender(paint, cellRect, cellValue, style, column, rowColumnIndex);
        }
    }
}

